package biblioteca;

import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SpringLayout;
import javax.swing.border.EmptyBorder;

public class Main extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = -4215535808099397733L;
	private JPanel contentPane;
	private JTextField txtAutore;
	private JTextField txtTitolo;
	private JTextField txtEditore;
	private JTextField txtCollocazione;
	private BufferedWriter bw;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		setTitle("Biblioteca");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		SpringLayout sl_contentPane = new SpringLayout();
		contentPane.setLayout(sl_contentPane);

		JLabel lblAutore = new JLabel("Autore");
		sl_contentPane.putConstraint(SpringLayout.NORTH, lblAutore, 10,
				SpringLayout.NORTH, contentPane);
		sl_contentPane.putConstraint(SpringLayout.WEST, lblAutore, 10,
				SpringLayout.WEST, contentPane);
		contentPane.add(lblAutore);

		txtAutore = new JTextField();
		sl_contentPane.putConstraint(SpringLayout.NORTH, txtAutore, 0,
				SpringLayout.NORTH, lblAutore);
		sl_contentPane.putConstraint(SpringLayout.WEST, txtAutore, 6,
				SpringLayout.EAST, lblAutore);
		contentPane.add(txtAutore);
		txtAutore.setColumns(30);

		JLabel lblTitolo = new JLabel("Titolo");
		sl_contentPane.putConstraint(SpringLayout.NORTH, lblTitolo, 6,
				SpringLayout.SOUTH, txtAutore);
		sl_contentPane.putConstraint(SpringLayout.WEST, lblTitolo, 0,
				SpringLayout.WEST, lblAutore);
		contentPane.add(lblTitolo);

		txtTitolo = new JTextField();
		sl_contentPane.putConstraint(SpringLayout.NORTH, txtTitolo, 6,
				SpringLayout.SOUTH, txtAutore);
		sl_contentPane.putConstraint(SpringLayout.WEST, txtTitolo, 0,
				SpringLayout.WEST, txtAutore);
		contentPane.add(txtTitolo);
		txtTitolo.setColumns(40);

		JLabel lblEditore = new JLabel("Editore");
		sl_contentPane.putConstraint(SpringLayout.NORTH, lblEditore, 6,
				SpringLayout.SOUTH, txtTitolo);
		sl_contentPane.putConstraint(SpringLayout.WEST, lblEditore, 0,
				SpringLayout.WEST, lblAutore);
		contentPane.add(lblEditore);

		txtEditore = new JTextField();
		sl_contentPane.putConstraint(SpringLayout.NORTH, txtEditore, 6,
				SpringLayout.SOUTH, txtTitolo);
		sl_contentPane.putConstraint(SpringLayout.WEST, txtEditore, 0,
				SpringLayout.WEST, txtAutore);
		contentPane.add(txtEditore);
		txtEditore.setColumns(20);

		JLabel lblCollocazione = new JLabel("Collocazione");
		sl_contentPane.putConstraint(SpringLayout.NORTH, lblCollocazione, 6,
				SpringLayout.SOUTH, txtEditore);
		sl_contentPane.putConstraint(SpringLayout.WEST, lblCollocazione, 0,
				SpringLayout.WEST, lblAutore);
		contentPane.add(lblCollocazione);

		txtCollocazione = new JTextField();
		sl_contentPane.putConstraint(SpringLayout.NORTH, txtCollocazione, 6,
				SpringLayout.SOUTH, txtEditore);
		sl_contentPane.putConstraint(SpringLayout.WEST, txtCollocazione, 6,
				SpringLayout.EAST, lblCollocazione);
		contentPane.add(txtCollocazione);
		txtCollocazione.setColumns(10);

		JButton btnApreArchivio = new JButton("Apre archivio");
		btnApreArchivio.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				btnApreArchivioActionPerformed();
			}
		});
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnApreArchivio, 6,
				SpringLayout.SOUTH, txtCollocazione);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnApreArchivio, 0,
				SpringLayout.WEST, lblAutore);
		contentPane.add(btnApreArchivio);

		JButton btnSalvaDati = new JButton("Salva dati");
		btnSalvaDati.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				btnSalvaDatiActionPerformed();
			}
		});
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnSalvaDati, 6,
				SpringLayout.SOUTH, txtCollocazione);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnSalvaDati, 6,
				SpringLayout.EAST, btnApreArchivio);
		contentPane.add(btnSalvaDati);

		JButton btnChiudeArchivio = new JButton("Chiude archivio");
		btnChiudeArchivio.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				btnChiudeArchivioActionPerformed();
			}
		});
		sl_contentPane.putConstraint(SpringLayout.NORTH, btnChiudeArchivio, 0,
				SpringLayout.NORTH, btnApreArchivio);
		sl_contentPane.putConstraint(SpringLayout.WEST, btnChiudeArchivio, 6,
				SpringLayout.EAST, btnSalvaDati);
		contentPane.add(btnChiudeArchivio);
	}

	public void btnApreArchivioActionPerformed() {
		try {
			FileWriter fw = new FileWriter("Biblioteca.csv", true);
			bw = new BufferedWriter(fw);
			JOptionPane.showMessageDialog(contentPane,
					"Archivio aperto in scrittura", "Avviso",
					JOptionPane.INFORMATION_MESSAGE);
		} catch (IOException e) {
			JOptionPane.showMessageDialog(contentPane,
					"Impossibile aprire l'archivio", "Errore",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	public void btnSalvaDatiActionPerformed() {
		try {
			String dato = txtAutore.getText() + ";" + txtTitolo.getText() + ";"
					+ txtEditore.getText() + ";" + txtCollocazione.getText();
			bw.write(dato);
			bw.newLine();
			JOptionPane.showMessageDialog(contentPane,
					"Dati salvati", "Avviso",
					JOptionPane.INFORMATION_MESSAGE);
			txtAutore.setText("");
			txtTitolo.setText("");
			txtEditore.setText("");
			txtCollocazione.setText("");
		} catch (IOException e) {
			JOptionPane.showMessageDialog(contentPane,
					"Impossibile salvare i dati", "Errore",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	public void btnChiudeArchivioActionPerformed() {
		try {
			bw.close();
			JOptionPane.showMessageDialog(contentPane,
					"Archivio chiuso", "Avviso",
					JOptionPane.INFORMATION_MESSAGE);
		} catch (IOException e) {
			JOptionPane.showMessageDialog(contentPane,
					"Impossibile chiudere l'archivio", "Errore",
					JOptionPane.ERROR_MESSAGE);
		}
	}
	
}
